#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_DropGoldCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_DropGoldCFG> Fish_DropGoldCFG::msSingleton(nullptr);

int Fish_DropGoldCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_DropGoldCFGData* Fish_DropGoldCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_DropGoldCFGData>& Fish_DropGoldCFG::GetMapData()
{
	return mMapData;
}

void Fish_DropGoldCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_DropGoldCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_DropGoldCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mResType = element->IntAttribute("ResType");
		data.mResName = element->Attribute("ResName");
		data.mResPath = element->Attribute("ResPath");
		data.mWidth = element->IntAttribute("Width");
		data.mHeight = element->IntAttribute("Height");
		data.mScale = element->FloatAttribute("Scale");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_DropGoldCFG::Load()
{
	Load("../Config/Fish_DropGoldCFG.xml");
}

Fish_DropGoldCFG* Fish_DropGoldCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_DropGoldCFG());
	}
	return msSingleton.get();
}
